/*
Module Name:

    ProtocolATM32.c


Revision History:

--*/
#include <winsock2.h>
//#include <direct.h>
#include <stdio.h>
//#include "ntddpack.h"
#include "conpack.h"
#include "winsvc.h" 
//#include "patmif.h"
//#include "common.h"
 
typedef int NDIS_STATUS, *PNDIS_STATUS; // note default size

#define STATUS_NOT_SUPPORTED           (0xC00000BBL)
#define NDIS_STATUS_NOT_SUPPORTED		((NDIS_STATUS)STATUS_NOT_SUPPORTED)


#define STATE_NOT_INSTALLED  0
#define STATE_INSTALLED      1
#define STATE_STARTED        2

static int ProtocolATMDriverState = STATE_NOT_INSTALLED;
static CHAR szError[257];



//
//  FUNCTION: GetLastErrorText
//
//  PURPOSE: copies error message text to string
//
//  PARAMETERS:
//    lpszBuf - destination buffer
//    dwSize - size of buffer
//
//  RETURN VALUE:
//    destination buffer
//
//  COMMENTS:
//
static char *GetLastErrorText( char *lpszBuf, DWORD dwSize )
{
   DWORD dwRet;
   char *lpszTemp = NULL;

   dwRet = FormatMessage( FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM |FORMAT_MESSAGE_ARGUMENT_ARRAY,
                          NULL,
                          GetLastError(),
                          LANG_NEUTRAL,
                          (LPTSTR)&lpszTemp,
                          0,
                          NULL );

   // supplied buffer is not long enough
   if ( !dwRet || ( (long)dwSize < (long)dwRet+14 ) )
      lpszBuf[0] = TEXT('\0');
   else
   {
      lpszTemp[lstrlen(lpszTemp)-2] = '\0';  //remove cr and newline character
      sprintf( lpszBuf, "%s (0x%x)", lpszTemp, GetLastError() );
   }

   if ( lpszTemp )
      LocalFree((HLOCAL) lpszTemp );

   return lpszBuf;
}

